'--------------------------------------------------------------------
'Quellprogramm: JULIA2.BAS
'--------------------------------------------------------------------
'Berechnung der ausgefuellten Julia-Menge
'fr die komplexe Iteration z(n+1) = z(n)^2 + c
'nach dem Level-Set-Algorithmus.
'Die Iterationstiefe wird schrittweise erhoeht und
'damit die Julia-Menge mit Niveauflaechen angenhert.
'--------------------------------------------------------------------
'Eingabewerte:
a = -1                    'Parameter c = (a,b)
b = 0
'--------------------------------------------------------------------

SCREEN 12                 'VGA, 640 x 480 Pixel, 16 Farben
px = 400: py = 400        'Bildschirmbereich

'z -Ebene                 'mathematischer Bereich
xmin = -4: xmax = 4       'Realteil
ymin = -4: ymax = 4       'Imaginaerteil

xschritt = (xmax - xmin) / px       'Schrittweite
yschritt = (ymax - ymin) / py

r = 2 + SQR(a ^ 2 + b ^ 2)          'Fluchtschranke
r2 = r ^ 2

CLS
FOR nmax = 0 TO 6
   'Berechnung der angenaeherten Julia-Menge durch
   'Abtasten der Bildschirmpunkte mit Test auf Mengenzugehoerigkeit
   FOR sx = 0 TO px                         'BildschirmSpalten
      x = xmin + sx * xschritt
      FOR zy = 0 TO py                      'BildschirmZeilen
         y = ymax - zy * yschritt
         x1 = x: y1 = y
         FOR n = 1 TO nmax                  'Iterationsschleife
            xx = x1 * x1 - y1 * y1 + a      'Hilfsgroesse
            y1 = 2 * x1 * y1 + b            'Imaginaerteil
            x1 = xx                         'Realteil
            IF x1 * x1 + y1 * y1 > r2 THEN EXIT FOR
         NEXT n
         'Punktausgabe
         IF x1 * x1 + y1 * y1 <= r2 THEN PSET (sx, zy), 5 + nmax
         NEXT zy
   NEXT sx
NEXT nmax

nmax = 100
'Berechnung der Julia-Menge
FOR sx = 0 TO px                         'BildschirmSpalten
   x = xmin + sx * xschritt
   FOR zy = 0 TO py                      'BildschirmZeilen
      y = ymax - zy * yschritt
      x1 = x: y1 = y
      FOR n = 1 TO nmax                  'Iterationsschleife
         xx = x1 * x1 - y1 * y1 + a      'Hilfsgroesse
         y1 = 2 * x1 * y1 + b            'Imaginaerteil
         x1 = xx                         'Realteil
         IF x1 * x1 + y1 * y1 > r2 THEN EXIT FOR
      NEXT n
      IF x1 * x1 + y1 * y1 <= r2 THEN PSET (sx, zy), 0
   NEXT zy
NEXT sx

PRINT "c-Parameter:"
PRINT "("; a; ","; b; ")"

END



